// FirCoeffView.cpp : CFirCoeffView NX̓̒`s܂B
// by Toshio Iwata at digitalfilter.com 2004/09/09

#include "stdafx.h"
#include "FirCoeff.h"

#include "FirCoeffDoc.h"
#include "FirCoeffView.h"
#include "DlgLpf.h"
#include "DlgHpf.h"
#include "DlgBpf.h"
#include "DlgBrf.h"
#include "DlgWarnFs.h"
#include "DlgRng.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFirCoeffView

IMPLEMENT_DYNCREATE(CFirCoeffView, CView)

BEGIN_MESSAGE_MAP(CFirCoeffView, CView)
	//{{AFX_MSG_MAP(CFirCoeffView)
	ON_COMMAND(ID_MENU_LPF, OnMenuLpf)
	ON_COMMAND(ID_MENU_HPF, OnMenuHpf)
	ON_COMMAND(ID_MENU_BPF, OnMenuBpf)
	ON_COMMAND(ID_MENU_BRF, OnMenuBrf)
	ON_COMMAND(ID_MENU_SV, OnMenuSv)
	ON_COMMAND(ID_MENU_RNG, OnMenuRng)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFirCoeffView NX̍\z/

CFirCoeffView::CFirCoeffView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	int i;
	for( i = 0; i < 400; i++ ) hh[i] = 0.0;
	Fsamp = 22050;
	gain_range = 100.0;
	freq_range = Fsamp/2.0;
	Pi = 3.14159;
	cosmeticTapN = 100;
	TapN = 99;
	TapN_2 = TapN/2;
	FresN = 400;
	lpf_fc1 = 3000;
	hpf_fc1 = 3000;
	bpf_fc1 = 3000;
	bpf_fc2 = 9000;
	brf_fc1 = 3000;
	brf_fc2 = 9000;
	alpha = 7.0;
	FilType = 0;
	design_clicked = FALSE;
}

CFirCoeffView::~CFirCoeffView()
{
}

BOOL CFirCoeffView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CFirCoeffView NX̕`

void CFirCoeffView::OnDraw(CDC* pDC)
{
	CFirCoeffDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	if(design_clicked) {
		PutParam();
		DoIdft();
		Kaiser(TapN, alpha);
		FirFresCal(Gain, Theta);
		FresDraw(pDC, 100, 60, Gain, Theta);
	} else {
		pDC->TextOut( 50, 50, "FirCoeff.exe");
		pDC->TextOut( 50, 80, "FIRtB^̌WZo܂B");
		pDC->TextOut( 50, 110, "u݌vvIĂB");
		pDC->TextOut( 50, 140, "by DIGITALFILTER.COM");
	}
}

/////////////////////////////////////////////////////////////////////////////
// CFirCoeffView NẌ

BOOL CFirCoeffView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CFirCoeffView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CFirCoeffView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CFirCoeffView NX̐ff

#ifdef _DEBUG
void CFirCoeffView::AssertValid() const
{
	CView::AssertValid();
}

void CFirCoeffView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFirCoeffDoc* CFirCoeffView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFirCoeffDoc)));
	return (CFirCoeffDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFirCoeffView NX̃bZ[W nh

void CFirCoeffView::DoIdft()
{
	int i,k;
	double omega;
	double cor[400], coi[400];

	for (i = 0; i < FresN; i++) {
		cor[i] = 0.0; coi[i] = 0.0; 
		for (k = 0; k < FresN; k++) {
			omega = 2.0 * Pi * k * i / FresN; 

			cor[i] += FresR[k] * cos(omega) - FresI[k] * sin(omega); 

			coi[i] += FresI[k] * cos(omega) + FresR[k] * sin(omega); 
		}
	}

	for (i = 0; i < FresN; i++) {
		cor[i] /= FresN; coi[i] /= FresN;
	}

	for (i = 0; i < 400; i++) hh[i] = 0;
	for (i = 0; i < TapN_2; i++) {
		hh[i] = cor[TapN_2-i];
	}
	for (i = TapN_2; i < 2*TapN_2+1; i++) {
		hh[i] = cor[i-TapN_2];
	}
}

void CFirCoeffView::PutParam()
{
	int i;
	int fc1int, fc2int;
	double Reduct = -200.0;
	double gain_fc1, gain_fc2, gain_fc3;

	if(FilType == 0) {
		fc1int = (int)(FresN * lpf_fc1 / Fsamp);
		fc2int = fc1int;
		gain_fc1 = pow(10.0, 0.0 / 20.0);
		gain_fc2 = pow(10.0, Reduct / 20.0);
		gain_fc3 = pow(10.0, Reduct / 20.0);
	} else if(FilType == 1) {
		fc1int = (int)(FresN * hpf_fc1 / Fsamp);
		fc2int = fc1int;
		gain_fc1 = pow(10.0, Reduct / 20.0);
		gain_fc2 = pow(10.0, 0.0 / 20.0);
		gain_fc3 = pow(10.0, 0.0 / 20.0);
	} else if(FilType == 2) {
		fc1int = (int)(FresN * bpf_fc1 / Fsamp);
		fc2int = (int)(FresN * bpf_fc2 / Fsamp);
		gain_fc1 = pow(10.0, Reduct / 20.0);
		gain_fc2 = pow(10.0, 0.0 / 20.0);
		gain_fc3 = pow(10.0, Reduct / 20.0);
	} else if(FilType == 3) {
		fc1int = (int)(FresN * brf_fc1 / Fsamp);
		fc2int = (int)(FresN * brf_fc2 / Fsamp);
		gain_fc1 = pow(10.0, 0.0 / 20.0);
		gain_fc2 = pow(10.0, Reduct / 20.0);
		gain_fc3 = pow(10.0, 0.0 / 20.0);
	}

	for (i = 0; i < fc1int; i++) {
		FresR[i]=gain_fc1;
	}
	for (i = fc1int; i < fc2int; i++) {
		FresR[i]=gain_fc2;
	}
	for (i = fc2int; i < FresN - fc2int; i++) {
		FresR[i]=gain_fc3;
	}
	for (i = FresN - fc2int; i < FresN - fc1int; i++) {
		FresR[i]=gain_fc2;
	}
	for (i = FresN - fc1int; i < FresN; i++) {
		FresR[i]=gain_fc1;
	}
	for (i = 0; i < FresN; i++) { // ̓[
		FresI[i]=0.0;
	}
}


void CFirCoeffView::FresDraw(CDC *pDC, int x0, int y0, double *Xg, double *Xt)
{
	double start_fr, end_fr, mid_fr;
	double tmp_xg[400], tmp_xt[400];
	int	i;
	char freq_char[15];
	char gain_char[15];
	double xstep = 2.0;

	CPen	myPen;
	CPen*	pOldPen;

	for (i = 0; i < 400; i++) tmp_xg[i] = 0.0;

	pDC->TextOut(x0 - 50, y0 -  28,"Gain [dB]");
	sprintf(gain_char,"%5.1f", gain_range/5.0);
	pDC->TextOut(x0 - 50, y0 -   8, gain_char);

	pDC->TextOut(x0 - 30, y0 +  32,"  0");

	sprintf(gain_char,"-%5.1f", gain_range/2.0);
	pDC->TextOut(x0 - 60, y0 + 132, gain_char);
	sprintf(gain_char,"-%5.1f", gain_range);
	pDC->TextOut(x0 - 60, y0 + 225, gain_char);
	
	pDC->TextOut(x0 + 360 - 10, y0 - 28,"Phase [rad]");
	pDC->TextOut(x0 + 360 + 10, y0 + 52,"  pi ");
	pDC->TextOut(x0 + 360 + 10, y0 + 92," pi/2");
	pDC->TextOut(x0 + 360 + 10, y0 + 132,"   0 ");
	pDC->TextOut(x0 + 360 + 10, y0 + 172,"-pi/2");
	pDC->TextOut(x0 + 360 + 10, y0 + 212," -pi ");

	start_fr = 0.0;
	end_fr = start_fr + freq_range / 1.0;
	mid_fr = start_fr + freq_range / 2.0;

	sprintf(freq_char,"%10.3f", start_fr);
	pDC->TextOut(x0 - 50, y0 + 250, freq_char);
	sprintf(freq_char,"%10.3f", mid_fr);
	pDC->TextOut(x0 - 10 + 150, y0 + 250, freq_char);
	sprintf(freq_char,"%10.3f", end_fr);
	pDC->TextOut(x0 - 10 + 330, y0 + 250, freq_char);
	pDC->TextOut(x0 - 10 + 410, y0 + 250,"[Hz]");

	myPen.CreatePen(PS_DOT, 1, RGB(100,100,100));
	pOldPen = pDC->SelectObject(&myPen);

	for(i = 0; i <= 12; i++) {
		pDC->MoveTo(x0      , y0 + i * 20);
		pDC->LineTo(x0 + 360, y0 + i * 20);
	}

	for(i = 0; i <= 10; i++) {
		pDC->MoveTo(x0 + i * (360 / 10), y0);
		pDC->LineTo(x0 + i * (360 / 10), y0 + 240);
	}

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	myPen.CreatePen(PS_DOT, 1, RGB(50,50,50));
	pOldPen = pDC->SelectObject(&myPen);

	pDC->MoveTo(x0      , y0 + 2 * 20);
	pDC->LineTo(x0 + 360, y0 + 2 * 20);

	pDC->MoveTo(x0 + 5 * (360 / 10), y0);
	pDC->LineTo(x0 + 5 * (360 / 10), y0 + 240);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	// Frame drawing
	for(i = 0; i <= 12; i = i + 12) {
		pDC->MoveTo(x0      , y0 + i * 20);
		pDC->LineTo(x0 + 360, y0 + i * 20);
	}
	for(i = 0; i <= 10; i = i + 10) {
		pDC->MoveTo(x0 + i * (360 / 10), y0);
		pDC->LineTo(x0 + i * (360 / 10), y0 + 240);
	}

	myPen.CreatePen(PS_SOLID, 1, RGB(0,255,0));
	pOldPen = pDC->SelectObject(&myPen);
	
	for(i = 0; i < 180; i++) {
    	tmp_xt[i] = 25.5 * Xt[i];
	}

	xstep = Fsamp/freq_range;

	for(i = 0; i < 179; i++) {
		if( (i+1)*xstep < 360 ) {
			pDC->MoveTo(x0 + (int)(i*xstep), y0 + 140 - (int)(tmp_xt[i]));
			pDC->LineTo(x0 + (int)((i+1)*xstep), y0 + 140 - (int)(tmp_xt[i + 1]));
		}
	}
	
	pDC->TextOut(x0 + 200, y0 - 40,"Phase");
   	pDC->MoveTo(x0 + 250, y0 - 30);
	pDC->LineTo(x0 + 270, y0 - 30);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();

	myPen.CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
	pOldPen = pDC->SelectObject(&myPen);

	double ymax, ymin, yrange;

	ymax = 40.0;
	ymin = -200.0;
	yrange = 2.0 * 100.0 / gain_range;

	for(i = 0; i < 180; i++) {
    	tmp_xg[i] = yrange * Xg[i];
		if( tmp_xg[i] < ymin ) tmp_xg[i] = ymin;
		if( tmp_xg[i] > ymax ) tmp_xg[i] = ymax;
	}

	for(i = 0; i < 179; i++) {
		if( (i+1)*xstep < 360 ) {
			pDC->MoveTo(x0 + (int)(i*xstep), y0 + 40 - (int)(tmp_xg[i]));
			pDC->LineTo(x0 + (int)((i+1)*xstep), y0 + 40 - (int)(tmp_xg[i + 1]));

		}
	}
	pDC->TextOut(x0 + 100, y0 - 40,"Gain");
   	pDC->MoveTo(x0 + 140, y0 - 30);
	pDC->LineTo(x0 + 160, y0 - 30);

	pDC->SelectObject(pOldPen);
	myPen.DeleteObject();
}

void CFirCoeffView::FirFresCal(double* Xg, double* Xt)
{
	int i, m;
	double	omega;
	double	AReal;
	double	AImag;
	double	AAbs_2;
	double	ATheta;

	double	HAbs_2;
	double	HzdB;
	double	HTheta;


	for(i = 0; i < 360; i++) {
		omega = i * Pi / 180.0 + 0.001;

		AReal = 0; AImag = 0;
		
		for(m =	0; m < TapN; m++) {
			AReal = AReal + hh[m] * cos(m * omega);
			AImag = AImag + hh[m] * sin(m * omega);
		}

		AAbs_2 = AReal * AReal + AImag * AImag;

		ATheta = (-1) * atan(AImag / AReal);

		HAbs_2 = AAbs_2;
		HzdB = 10 * log10(HAbs_2);
		HTheta = ATheta;
		Xg[i] = HzdB;
		Xt[i] = HTheta;
	}
}

void CFirCoeffView::Kaiser(int n, double alpha) {
	double win[400];
	double ERR = 1e-14;
	int i;
	double old, diff, p, r, t;
	double i1, i2;
	double a,g;
                                          
	old = p = 0.0;
	i2 = r = diff = 1.0;
	t = (double)(alpha / 2);
	while(diff < -ERR || diff > ERR) {
		p += 1.0;
		r *= (t/p);
		i2 += r*r;
		diff = old - i2;
		old = i2;
	}
	a = (double)(n - 1) / 2;
	for(i = 0; i < n; i++) {
		g = ((double)i - a) / a;
		t = (double)(alpha * sqrt(1.0 - g*g));
		old = p = 0.0;
		i1 = r = diff = 1.0;
		t /= 2;
		while(diff < -ERR || diff > ERR) {
			p += 1.0;
			r *= (t/p);
			i1 += r*r;
			diff = old - i1;
			old = i1;
		}
		win[i] = i1 / i2;
	}
	for(i = 0; i < n; i++) hh[i] *= win[i];
}

void CFirCoeffView::OnMenuLpf() 
{
	CDlgLpf dlg;

	dlg.m_fc1 = lpf_fc1;
	dlg.m_tapn = cosmeticTapN;
	dlg.m_alpha = alpha;
	dlg.m_fs = Fsamp;
	if (dlg.DoModal() == IDOK) {
		if( dlg.m_fc1 >= dlg.m_fs/2 ) {
			CDlgWarnFs dlgW;
			if (dlgW.DoModal() == IDOK) {
			}
		} else {
			lpf_fc1 = dlg.m_fc1;
			cosmeticTapN = dlg.m_tapn;
			alpha = dlg.m_alpha;
			Fsamp = dlg.m_fs;
			freq_range = Fsamp/2;
			FilType = 0;
			if( cosmeticTapN % 2 == 0 ) TapN = cosmeticTapN - 1; // ۂ̃^bviTapN)͊łȂ΂ȂȂ
			else TapN = cosmeticTapN;
			TapN_2 = TapN/2;
			design_clicked = TRUE;
		}
		InvalidateRect(NULL, TRUE);
	}
}

void CFirCoeffView::OnMenuHpf() 
{
	CDlgHpf dlg;

	dlg.m_fc1 = hpf_fc1;
	dlg.m_tapn = cosmeticTapN;
	dlg.m_alpha = alpha;
	dlg.m_fs = Fsamp;
	if (dlg.DoModal() == IDOK) {
		if( dlg.m_fc1 >= dlg.m_fs/2 ) {
			CDlgWarnFs dlgW;
			if (dlgW.DoModal() == IDOK) {
			}
		} else {
			hpf_fc1 = dlg.m_fc1;
			cosmeticTapN = dlg.m_tapn;
			alpha = dlg.m_alpha;
			Fsamp = dlg.m_fs;
			freq_range = Fsamp/2;
			FilType = 1;
			if( cosmeticTapN % 2 == 0 ) TapN = cosmeticTapN - 1;
			else TapN = cosmeticTapN;
			TapN_2 = TapN/2;
			design_clicked = TRUE;
		}
		InvalidateRect(NULL, TRUE);
	}
}

void CFirCoeffView::OnMenuBpf() 
{
	CDlgBpf dlg;

	dlg.m_fc1 = bpf_fc1;
	dlg.m_fc2 = bpf_fc2;
	dlg.m_tapn = cosmeticTapN;
	dlg.m_alpha = alpha;
	dlg.m_fs = Fsamp;
	if (dlg.DoModal() == IDOK) {
		if( dlg.m_fc1 >= dlg.m_fs/2 || dlg.m_fc2 >= dlg.m_fs/2 ) {
			CDlgWarnFs dlgW;
			if (dlgW.DoModal() == IDOK) {
			}
		} else {
			bpf_fc1 = dlg.m_fc1;
			bpf_fc2 = dlg.m_fc2;
			cosmeticTapN = dlg.m_tapn;
			alpha = dlg.m_alpha;
			Fsamp = dlg.m_fs;
			freq_range = Fsamp/2;
			FilType = 2;
			if( cosmeticTapN % 2 == 0 ) TapN = cosmeticTapN - 1;
			else TapN = cosmeticTapN;
			TapN_2 = TapN/2;
			design_clicked = TRUE;
		}
		InvalidateRect(NULL, TRUE);
	}
}

void CFirCoeffView::OnMenuBrf() 
{
	CDlgBrf dlg;

	dlg.m_fc1 = brf_fc1;
	dlg.m_fc2 = brf_fc2;
	dlg.m_tapn = cosmeticTapN;
	dlg.m_alpha = alpha;
	dlg.m_fs = Fsamp;
	if (dlg.DoModal() == IDOK) {
		if( dlg.m_fc1 >= dlg.m_fs/2 || dlg.m_fc2 >= dlg.m_fs/2 ) {
			CDlgWarnFs dlgW;
			if (dlgW.DoModal() == IDOK) {
			}
		} else {
			brf_fc1 = dlg.m_fc1;
			brf_fc2 = dlg.m_fc2;
			cosmeticTapN = dlg.m_tapn;
			alpha = dlg.m_alpha;
			Fsamp = dlg.m_fs;
			freq_range = Fsamp/2;
			FilType = 3;
			if( cosmeticTapN % 2 == 0 ) TapN = cosmeticTapN - 1;
			else TapN = cosmeticTapN;
			TapN_2 = TapN/2;
			design_clicked = TRUE;
		}
		InvalidateRect(NULL, TRUE);
	}
}

void CFirCoeffView::OnMenuSv() 
{
	SaveCoeff();
}

void CFirCoeffView::SaveCoeff()
{
	FILE *fpo;

	CFileDialog dlgF(FALSE, NULL, "coeff1.txt");
	if( dlgF.DoModal() == IDOK)	{
		//filenameɑIt@C̃tpX
		filenamesv = dlgF.GetPathName();
		fpo = fopen( filenamesv, "w" );
		//ȍ~t@CɃf[^
		if (fpo != NULL) { 
			for( int i = 0; i < cosmeticTapN; i++ ) {
				fprintf(fpo, "%14.9f\n", hh[i]);
			}
		}
		fclose(fpo);
	} 
	InvalidateRect(NULL, TRUE);	
}

void CFirCoeffView::OnMenuRng() 
{
	CDlgRng dlg;

	dlg.m_grng = gain_range;
	dlg.m_frng = freq_range;
	if (dlg.DoModal() == IDOK) {
		gain_range = dlg.m_grng;
		freq_range = dlg.m_frng;
		InvalidateRect(NULL, TRUE);
	}	
}

void CFirCoeffView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CRect rectClient;
	GetClientRect(&rectClient);
	pDC -> SetMapMode(MM_ANISOTROPIC);
	pDC -> SetWindowOrg(0,0);
	pDC -> SetWindowExt(100,50);
	pDC -> SetViewportOrg(0,0);
	pDC -> SetViewportExt(550, 350); // `TCYݒ

	CFont* pfontCurrent = pDC -> GetCurrentFont();
	LOGFONT lfCurrentFont;
	pfontCurrent -> GetObject(sizeof(LOGFONT), &lfCurrentFont);
	CFont fontBig;
	lfCurrentFont.lfHeight = 15; // tHgTCYijݒ
	lfCurrentFont.lfWidth = 8; // tHgTCYijݒ

	fontBig.CreateFontIndirect(&lfCurrentFont);
	CFont* defaultFont = (CFont*)pDC -> SelectObject(&fontBig);

	CView::OnPrint(pDC, pInfo);
}
